/* ******************************************************************
   Class Bin
   Used to keep record on the distribution of the nodes
   on C-space
   Each bin containts an identifier, given by i, a counter where the
   number of nodes in the bin is kept (count), and a space to store
   a certain number of nodes per bin. There are also some auxiliary
   functions.
 
   Gildardo Sanchez-Ante
   Robotics Lab., Stanford University
   **************************************************************** */

#ifndef BIN_H
#define BIN_H

#include <iostream.h>
#include <vector.h>

#include "Milestone.h"


class Bin {

 public:
 
  // Default constructor
  Bin() {}

  //Destructor
  ~Bin() {}

  // Constructor that receives a milestone
  Bin(const Milestone& m)
    {
      // Add the node index at the first position
      data.push_back(m.getIndex());
   }

  void add_node(const Milestone& node)
    { 
      data.push_back(node.getIndex());
    }

  void del_node(const Milestone& node)
    { 
      vector<int>::iterator I;
      for(I=data.begin();I!=data.end();++I)
	if((*I)== node.getIndex())
	  break;  
      data.erase(I);
    }
  
  int getSize()
    {return data.size();}

  int getData(int i)
    { 
      return data[i];
    }

  void print()
    {
      vector<int>::iterator I;
      for(I=data.begin();I!=data.end();++I)
	cerr<<(*I)<<", ";
      cerr<<endl;
}

  vector<int> data;     // To store the indexes of the nodes on the bin
};


istream& operator>> (istream& is, Milestone& m);
ostream& operator<< (ostream& os, const Milestone& m);

#endif











