///////////////////////////////////////////////////////////////////////
//
// File:	ColPrimitives.h
//
// Authors:	James Kuffner & David Hsu
// Created:	April 2, 1998
//
// Data type definitions for collision checking primitives
//
///////////////////////////////////////////////////////////////////////

#ifndef COL_PRIMITIVES_H
#define COL_PRIMITIVES_H

// basic types
typedef double ColReal;

typedef ColReal ColPoint3[3];
typedef ColReal ColVector3[3];
typedef ColReal ColMatrix3[3][3];

typedef ColPoint3 ColPolygon[];


// boolean
//ifndef _BOOL 
/* bool not predefined */ 
//define _BOOL
//typedef unsigned char bool; 
//static const bool false = 0; 
//static const bool true = 1; 
//endif /* _BOOL */

#ifndef TRUE
#define TRUE  true 
#endif

#ifndef FALSE
#define FALSE false
#endif


// null
#ifndef NULL
#define NULL 0
#endif /* NULL */


#endif // COL_PRIMITIVES_H
