
//////////////////////////////////////////////////////////////
//
// Header file for EditBoard
//
//    This file is generated by RapidApp 1.2
//
//    This class is derived from EditBoardUI which 
//    implements the user interface created in 
//    RapidApp. This class contains virtual
//    functions that are called from the user interface.
//
//    When you modify this header file, limit your changes to those
//    areas between the "//---- Start/End editable code block" markers
//
//    This will allow RapidApp to integrate changes more easily
//
//    This class is a ViewKit user interface "component".
//    For more information on how components are used, see the
//    "ViewKit Programmers' Manual", and the RapidApp
//    User's Guide.
//////////////////////////////////////////////////////////////
#ifndef EDITBOARD_H
#define EDITBOARD_H
#include "EditBoardUI.h"

//---- Start editable code block: headers and declarations

class EditMainWindow;

//---- End editable code block: headers and declarations


//---- EditBoard class declaration

class EditBoard : public EditBoardUI
{

  public:

    EditBoard ( const char *, Widget );
    EditBoard ( const char * );
    ~EditBoard();
    const char *  className();

    static VkComponent *CreateEditBoard( const char *name, Widget parent ); 

    //---- Start editable code block: EditBoard public

    Widget *jointList() {return &_jointList;}
		Widget *dofScale() {return &_dofScale;}
		Widget *dofNum() {return &_dofNum;}
		class SoXtExaminerViewer *jointViewer() {return _jointViewer;}
		void setEditor(EditMainWindow *editor_) {editor = editor_;}

    //---- End editable code block: EditBoard public



  protected:


    // These functions will be called as a result of callbacks
    // registered in EditBoardUI

    virtual void doSelectJoint ( Widget, XtPointer );
    virtual void doSetDof ( Widget, XtPointer );

    //---- Start editable code block: EditBoard protected


    //---- End editable code block: EditBoard protected



  private:

    static void* RegisterEditBoardInterface();

    //---- Start editable code block: EditBoard private


		EditMainWindow *editor;

    //---- End editable code block: EditBoard private


};
//---- Start editable code block: End of generated code


//---- End editable code block: End of generated code

#endif

