
//////////////////////////////////////////////////////////////
//
// Header file for EditMainWindow
//
//    This class is a subclass of VkSimpleWindow
//
// Normally, very little in this file should need to be changed.
// Create/add/modify menus using RapidApp.
//
// Restrict changes to those sections between
// the "//--- Start/End editable code block" markers
// Doing so will allow you to make changes using RapidApp
// without losing any changes you may have made manually
//
//////////////////////////////////////////////////////////////
#ifndef EDITMAINWINDOW_H
#define EDITMAINWINDOW_H
#include <Vk/VkSimpleWindow.h>


//---- Start editable code block: headers and declarations

class IVSimulator;
class SoCamera;
class SoDragger;
class SoSeparator;
class SoTransformBoxManip;
class SoXtExaminerViewer;
class JointKit;
class Joint;

//---- End editable code block: headers and declarations


//---- EditMainWindow class declaration


class EditMainWindow: public VkSimpleWindow {

  public:

  static int rob; //For the number of robot to show and modify

    EditMainWindow( const char * name, 
                    ArgList args = NULL,
                    Cardinal argCount = 0 );
    ~EditMainWindow();
    const char *className();
    virtual Boolean okToQuit();

    //---- Start editable code block: EditMainWindow public

		void setSim(IVSimulator *sim_);
		void setRob(int n=0){num_rob=n;};
		void resetSim();
		void setCamera(SoCamera *cam);
		void selectJointKit(const char *jointKitName);
		void setDof(int dof, double newVal);
		int num_rob;

    //---- End editable code block: EditMainWindow public
	
  protected:

    // Classes created by this class

    class EditBoard *_editBoard;


    // Widgets created by this class



    //---- Start editable code block: EditMainWindow protected


    //---- End editable code block: EditMainWindow protected


  private:


    static String  _defaultEditMainWindowResources[];


    //---- Start editable code block: EditMainWindow private

		Widget *jointList();
    SoXtExaminerViewer *jointViewer();

		SoSeparator *manipRoot;
		SoTransformBoxManip *manipNode;
		IVSimulator *sim;
		JointKit *selJointKit;
		Joint *selJoint;
		

		//static void modifyManip(void *userData, SoDragger *dragger);
		//static void resetModel(JointKit *kit);
    //---- End editable code block: EditMainWindow private


};
//---- Start editable code block: End of generated code


//---- End editable code block: End of generated code

#endif
























