#ifndef Obstacle_h
#define Obstacle_h

#include <Inventor/nodekits/SoBaseKit.h>
#include <Inventor/fields/SoSFNode.h>

#include <Inventor/SbLinear.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/actions/SoCallbackAction.h>
#include <Inventor/SoPrimitiveVertex.h>
#include <PQP.h>

class SoPrimitiveVertex;
class SoPath;
class ObstacleKit;


class Obstacle : public SoSeparator {

   SO_NODE_HEADER(Obstacle);

 
 public:
  // Methods
  Obstacle();
  static void initClass();
  void buildColModel();
  PQP_Model *getColModel();
  void initTransform();
  void setTranslation(double x, double y, double z);
 
  static void _TriangulateCB(void *data, SoCallbackAction *,
			     const SoPrimitiveVertex *vertex1,
			     const SoPrimitiveVertex *vertex2,
			     const SoPrimitiveVertex *vertex3);	
  //protected:
  virtual ~Obstacle();

  //Non-Inventor data members
  PQP_Model  *colModel;  // Shape (collision checking)
  PQP_Model  *oldObjModel;
  double dist;
  double tol;

  PQP_REAL rot[3][3];
  PQP_REAL trans[3];
};

#endif


































