#ifndef SAMPLE_H
#define SAMPLE_H

#include "list.h"

class SampleRandomConfig;
class RobotSimulator;
class Milestone;


/* Sample
 *
 *   This class contains different algorithms to generate random milestones
 *   from an appropriate representation of the c-space
 */

class Sample {

public:
  static void Reject(RobotSimulator *robot, SampleRandomConfig* sampler,
		     Milestone *m);
  static void Reject(RobotSimulator *robot, SampleRandomConfig* sampler,
		     int n, list<Milestone> *milestones);
  static void LocalReject(RobotSimulator *robot, SampleRandomConfig* sampler,
			  const Milestone& m0, double radius, Milestone *m);
  static void LocalReject(RobotSimulator *robot, SampleRandomConfig* sampler,
			  const Milestone& m0, double radius, int n, 
			  list<Milestone> *milestones);
};

#endif
