#ifndef SAMPLE_RANDOM_CONFIG_H
#define SAMPLE_RANDOM_CONFIG_H


class GenCoords;


/* SampleRandomConfig
 *
 *    abstract base class for generating random configurations
 */

class SampleRandomConfig {

public:

  //
  // pick uniformly at random a configuration
  //
  virtual void UniformSample(GenCoords *q)=0 ;

  //
  // pick uniformly at random a configuraton in the neighborhood centered
  // at q0 and with radius radius (0 <= radius <= 0.5)
  //
  //
  virtual bool LocalUniformSample( const GenCoords& q0, double radius,
				   GenCoords *q )=0;
};

#endif 
