
//////////////////////////////////////////////////////////////
//
// Header file for ViewBoard
//
//    This file is generated by RapidApp 1.2
//
//    This class is derived from ViewBoardUI which 
//    implements the user interface created in 
//    RapidApp. This class contains virtual
//    functions that are called from the user interface.
//
//    When you modify this header file, limit your changes to those
//    areas between the "//---- Start/End editable code block" markers
//
//    This will allow RapidApp to integrate changes more easily
//
//    This class is a ViewKit user interface "component".
//    For more information on how components are used, see the
//    "ViewKit Programmers' Manual", and the RapidApp
//    User's Guide.
//////////////////////////////////////////////////////////////
#ifndef VIEWBOARD_H
#define VIEWBOARD_H
#include "ViewBoardUI.h"

//---- Start editable code block: headers and declarations

class ViewMainWindow;

//---- End editable code block: headers and declarations


//---- ViewBoard class declaration

class ViewBoard : public ViewBoardUI
{

  public:

    ViewBoard ( const char *, Widget );
    ViewBoard ( const char * );
    ~ViewBoard();
    const char *  className();

    static VkComponent *CreateViewBoard( const char *name, Widget parent ); 

    //---- Start editable code block: ViewBoard public

		void setViewer(ViewMainWindow *viewer_) {viewer = viewer_;}

    //---- End editable code block: ViewBoard public



  protected:


    // These functions will be called as a result of callbacks
    // registered in ViewBoardUI

    virtual void doPlayB ( Widget, XtPointer );
    virtual void doPlayE ( Widget, XtPointer );
    virtual void doPlayF ( Widget, XtPointer );
    virtual void doPlayP ( Widget, XtPointer );
    virtual void doPlayR ( Widget, XtPointer );
    virtual void doPlaySF ( Widget, XtPointer );
    virtual void doPlaySR ( Widget, XtPointer );
    virtual void setAnimToggle ( Widget, XtPointer );
    virtual void setFrameRate ( Widget, XtPointer );
    virtual void setPathToggle ( Widget, XtPointer );

    //---- Start editable code block: ViewBoard protected


    //---- End editable code block: ViewBoard protected



  private:

    static void* RegisterViewBoardInterface();

    //---- Start editable code block: ViewBoard private

		ViewMainWindow *viewer;

    //---- End editable code block: ViewBoard private


};
//---- Start editable code block: End of generated code


//---- End editable code block: End of generated code

#endif

