
//////////////////////////////////////////////////////////////
//
// Header file for ViewBoardUI
//
//    This file is generated by RapidApp 1.2
//
//    This class implements the user interface portion of a class
//    Normally it is not used directly.
//    Instead the subclass, ViewBoard is instantiated
//
//    To extend or alter the behavior of this class, you should
//    modify the ViewBoard files
//
//    Restrict changes to those sections between
//    the "//--- Start/End editable code block" markers
//
//    This will allow RapidApp to integrate changes more easily
//
//    This class is a ViewKit user interface "component".
//    For more information on how components are used, see the
//    "ViewKit Programmers' Manual", and the RapidApp
//    User's Guide.
//
//////////////////////////////////////////////////////////////
#ifndef VIEWBOARDUI_H
#define VIEWBOARDUI_H
#include <Vk/VkComponent.h>


//---- Start editable code block: headers and declarations


//---- End editable code block: headers and declarations


class ViewBoardUI : public VkComponent
{ 

  public:

    ViewBoardUI ( const char *, Widget );
    ViewBoardUI ( const char * );
    ~ViewBoardUI();
    void create ( Widget );
    const char *  className();

    //---- Start editable code block: ViewBoard public


    //---- End editable code block: ViewBoard public


  protected:


    // Widgets created by this class

    Widget  _animToggle;
    Widget  _frLabel;
    Widget  _frLabel1;
    Widget  _frScale;
    Widget  _label;
    Widget  _pathToggle;
    Widget  _playB;
    Widget  _playE;
    Widget  _playF;
    Widget  _playP;
    Widget  _playR;
    Widget  _playSF;
    Widget  _playSR;
    Widget  _viewBoard;


    // These virtual functions are called from the private callbacks (below)
    // Intended to be overriden in derived classes to define actions

    virtual void doPlayB ( Widget, XtPointer );
    virtual void doPlayE ( Widget, XtPointer );
    virtual void doPlayF ( Widget, XtPointer );
    virtual void doPlayP ( Widget, XtPointer );
    virtual void doPlayR ( Widget, XtPointer );
    virtual void doPlaySF ( Widget, XtPointer );
    virtual void doPlaySR ( Widget, XtPointer );
    virtual void setAnimToggle ( Widget, XtPointer );
    virtual void setFrameRate ( Widget, XtPointer );
    virtual void setPathToggle ( Widget, XtPointer );

    //---- Start editable code block: ViewBoard protected


    //---- End editable code block: ViewBoard protected


  private: 

    // Array of default resources

    static String      _defaultViewBoardUIResources[];


    // Callbacks to interface with Motif

    static void doPlayBCallback ( Widget, XtPointer, XtPointer );
    static void doPlayECallback ( Widget, XtPointer, XtPointer );
    static void doPlayFCallback ( Widget, XtPointer, XtPointer );
    static void doPlayPCallback ( Widget, XtPointer, XtPointer );
    static void doPlayRCallback ( Widget, XtPointer, XtPointer );
    static void doPlaySFCallback ( Widget, XtPointer, XtPointer );
    static void doPlaySRCallback ( Widget, XtPointer, XtPointer );
    static void setAnimToggleCallback ( Widget, XtPointer, XtPointer );
    static void setFrameRateCallback ( Widget, XtPointer, XtPointer );
    static void setPathToggleCallback ( Widget, XtPointer, XtPointer );

    //---- Start editable code block: ViewBoard private


    //---- End editable code block: ViewBoard private
};
//---- Start editable code block: End of generated code


//---- End editable code block: End of generated code

#endif

