
//////////////////////////////////////////////////////////////
//
// Header file for ViewMainWindow
//
//    This class is a subclass of VkSimpleWindow
//
//           One Robot
//////////////////////////////////////////////////////////////
#ifndef VIEWMAINWINDOW_H
#define VIEWMAINWINDOW_H
#include <Vk/VkSimpleWindow.h>


//---- Start editable code block: headers and declarations

#include "Path.h"
#include "GenCoords.h"

class IVSimulator;
class SoTimerSensor;
class SoSwitch;

typedef struct {
	IVSimulator *sim;
	SoSwitch *wp, *owp;
	Path p; 
  
	bool dir, res, valid, enabled;

	Path::const_iterator it;
} animS;

//---- End editable code block: headers and declarations


//---- ViewMainWindow class declaration

class ViewMainWindow: public VkSimpleWindow {

  public:

    ViewMainWindow( const char * name, 
                    ArgList args = NULL,
                    Cardinal argCount = 0 );
    ~ViewMainWindow();
    const char *className();
    virtual Boolean okToQuit();

    //---- Start editable code block: ViewMainWindow public

		void setSim(IVSimulator *sim);
		bool toggleAnimation(bool newVal);
		bool togglePath(bool newVal);
		void animCmd(int cmd);
		void setFrameRate(int newRate);

		void setPath(const Path &p, SoSwitch *wp_ = NULL);
    //---- End editable code block: ViewMainWindow public


  protected:



    // Classes created by this class

    class ViewBoard *_viewBoard;


    // Widgets created by this class



    //---- Start editable code block: ViewMainWindow protected


    //---- End editable code block: ViewMainWindow protected


  private:


    static String  _defaultViewMainWindowResources[];


    //---- Start editable code block: ViewMainWindow private

		animS *anim;
		SoTimerSensor *animSensor;
		GenCoords q;

    //---- End editable code block: ViewMainWindow private


};
//---- Start editable code block: End of generated code


//---- End editable code block: End of generated code

#endif
