#ifndef jointkit_h
#define jointkit_h

#include <Inventor/nodekits/SoBaseKit.h>
#include <Inventor/fields/SoSFNode.h>
#include <Inventor/SbLinear.h>

class JointKit : public SoBaseKit {

  SO_KIT_HEADER(JointKit);

  // Fields for parts:

  SO_KIT_CATALOG_ENTRY_HEADER(topSeparator);
  SO_KIT_CATALOG_ENTRY_HEADER(parentTrans);
  SO_KIT_CATALOG_ENTRY_HEADER(joint);
  SO_KIT_CATALOG_ENTRY_HEADER(localTrans);
  SO_KIT_CATALOG_ENTRY_HEADER(link);
  SO_KIT_CATALOG_ENTRY_HEADER(children);

 public:

  JointKit();
  static void initClass();

  void updateMatrix(bool propagate = true);
  void updateChildren();
  void accuMatrix(const SbMatrix& upMatrix_); 
  const SbMatrix &getAccuMatrix() const {return accMatrix;}

 private:
  virtual ~JointKit();
  SbMatrix locMatrix, accMatrix, upMatrix;
};

#endif

