#ifndef STL_EXT_H
#define STL_EXT_H

/* FOR_EACH
 *   a macro to iterate through a container
 */

#ifndef ForEach
#define ForEach(iter, container) \
  for(iter=(container).begin(); iter != (container).end(); iter++)
#endif


/* add
 *   point arithmetic on list iterators
 *
 *   precondition : n > 0
 *                  T is of bidirectional iterator type
 *
 */

template<class T>
inline T
add(T p, int n)
{
  switch (n) {
  case 1: 
    return (++p); 
  case 2: 
    return (++(++p));
  default:
    while (n > 0) {
      p++; n--;
    }
    return p;
  }
}


/* sub
 *   point arithmetic on list iterators
 *
 *   precondition :  n > 0
 *                   T is of bidirectional iterator type
 *
 */

template <class T>
inline T
sub(T p, int n)
{
  switch (n) {
  case 1: 
    return (--p); 
  case 2: 
    return (--(--p)); 
  default:
    while (n > 0) {
      p--; n--;
    }
    return p;
  }
}


#endif
