
/////////////////////////////////////////////////////////////
//
// Source file for EditBoard
//
//    This file is generated by RapidApp 1.2
//
//    This class is derived from EditBoardUI which 
//    implements the user interface created in 
//    RapidApp. This class contains virtual
//    functions that are called from the user interface.
//
//    When you modify this source, limit your changes to 
//    modifying the sections between the
//    "//---- Start/End editable code block" markers
//
//    This will allow RapidApp to integrate changes more easily
//
//    This class is a ViewKit user interface "component".
//    For more information on how components are used, see the
//    "ViewKit Programmers' Manual", and the RapidApp
//    User's Guide.
/////////////////////////////////////////////////////////////

#include "EditBoard.h"
#include <Vk/VkEZ.h>
#include <Xm/BulletinB.h> 
#include <Xm/List.h> 
#include <Xm/Scale.h> 
#include <Xm/ScrolledW.h> 
#include <Vk/VkResource.h>


// Externally defined classes referenced by this class:

#include <Inventor/Xt/viewers/SoXtExaminerViewer.h>
#include <Inventor/So.h> // Includes ALL Inventor headers.
                         // Replace for efficiency and faster compilaton
#include <Vk/VkSimpleWindow.h>


extern void VkUnimplemented ( Widget, const char * );

///////////////////////////////////////////////////////////////////////////////
// The following non-container elements are created by EditBoardUI and are
// available as protected data members inherited by this class
//
//  XmScale		    _dofNum
//  XmScale		    _dofScale
//  XmList		    _jointList
//
// The following components are created by EditBoardUI and are
// available as protected data members inherited by this class
//
//  SoXtExaminerViewer		   *_jointViewer
//
///////////////////////////////////////////////////////////////////////////////


//---- Start editable code block: headers and declarations

#include "EditMainWindow.h"
//---- End editable code block: headers and declarations



//---- EditBoard Constructor

EditBoard::EditBoard(const char *name, Widget parent) : 
                   EditBoardUI(name, parent) 
{ 
    // This constructor calls EditBoardUI(parent, name)
    // which calls EditBoardUI::create() to create
    // the widgets for this component. Any code added here
    // is called after the component's interface has been built

    //---- Start editable code block: EditBoard constructor

	editor = NULL;

    //---- End editable code block: EditBoard constructor



}    // End Constructor



EditBoard::EditBoard(const char *name) : 
                   EditBoardUI(name) 
 { 
    // This constructor calls EditBoardUI(name)
    // which does not create any widgets. Usually, this
    // constructor is not used

    //---- Start editable code block: EditBoard constructor 2


    //---- End editable code block: EditBoard constructor 2



}    // End Constructor



EditBoard::~EditBoard()
{
    // The base class destructors are responsible for
    // destroying all widgets and objects used in this component.
    // Only additional items created directly in this class
    // need to be freed here.

    //---- Start editable code block: EditBoard destructor


    //---- End editable code block: EditBoard destructor



}    // End Destructor


const char * EditBoard::className() // classname
{
    return ("EditBoard");
} // End className()


void EditBoard::doSelectJoint ( Widget w, XtPointer callData )
{
 
  //---- Start editable code block: EditBoard doSelectJoint
  
  XmListCallbackStruct *cbs = (XmListCallbackStruct*) callData;
  
  if (editor != NULL)
    editor->selectJointKit(XmCvtXmStringToCT(cbs->item));
  //---- End editable code block: EditBoard doSelectJoint
  
}    // End EditBoard::doSelectJoint()


void EditBoard::doSetDof ( Widget w, XtPointer callData )
{
  //---- Start editable code block: EditBoard doSetDof
  
  XmScaleCallbackStruct *cbs = (XmScaleCallbackStruct*) callData;

  if (editor != NULL)
    editor->setDof((int)EZ(_dofNum), cbs->value/100.);
  
  //---- End editable code block: EditBoard doSetDof

}    // End EditBoard::doSetDof()





///////////////////////////////////////////////////////////////////
// static creation function, for importing class into rapidapp
// or dynamically loading, using VkComponent::loadComponent
///////////////////////////////////////////////////////////////////


VkComponent *EditBoard::CreateEditBoard( const char *name, Widget parent ) 
{  
    VkComponent *obj =  new EditBoard ( name, parent );
    return ( obj );
} // End CreateEditBoard


///////////////////////////////////////////////////////////////////
// Function for accessing a description of the dynamic interface
// to this class.
///////////////////////////////////////////////////////////////////


// WARNING: This structure is different than that used with 1.1 RapidApp.
// See the RapidApp release notes for details

struct InterfaceMap {
  char  *resourceName;
  char  *methodName;
  char  *argType;
  char  *definingClass; // Optional, if not this class
  void (VkCallbackObject::*method)(...); // Reserved, do not set
};


void *EditBoard::RegisterEditBoardInterface()
{ 
    // This structure registers information about this class
    // that allows RapidApp to create and manipulate an instance.
    // Each entry provides a resource name that will appear in the
    // resource manager palette when an instance of this class is
    // selected, the name of the member function as a string,
    // the type of the single argument to this function, and an.
    // optional argument indicating the class that defines this function.
    // All member functions must have the form
    //  
    //     void memberFunction ( Type );
    //
    // where "Type" is one of:
    //    const char *    (Use XmRString)
    //    Boolean         (Use XmRBoolean)
    //    int             (Use XmRInt)
    //    float           (Use XmRFloat)
    //    No argument     (Use VkRNoArg or "NoArg"
    //    A filename      (Use VkRFilename or "Filename")
    //    An enumeration  (Use "Enumeration:ClassName:Type: VALUE1, VALUE2, VALUE3")
    //    A callback      (Use XmRCallback)


    static InterfaceMap map[] = {
    //---- Start editable code block: EditBoardUI resource table

      // { "resourceName", "setAttribute", XmRString},
    //---- End editable code block: EditBoardUI resource table
      { NULL }, // MUST be NULL terminated
    };

    return map;
} // End RegisterEditBoardInterface()






//---- End of generated code

//---- Start editable code block: End of generated code


//---- End editable code block: End of generated code















