/* ************************************************
File ObstacleKit.C
     Enables the definition, creation and management
     of mobile obstacles in the workspace

     Gildardo Sanchez-Ante      
     Robotics Lab., Stanford University 
   ************************************************
*/

#include <Inventor/SoPrimitiveVertex.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoShape.h>
#include <Inventor/nodes/SoTranslation.h>
#include <Inventor/nodes/SoRotation.h>
#include <Inventor/actions/SoCallbackAction.h>

#include <iostream.h>

#include "ObstacleKit.h"

SO_KIT_SOURCE(ObstacleKit);

void 
ObstacleKit::initClass() {
  SO_KIT_INIT_CLASS(ObstacleKit, SoBaseKit, "BaseKit");
}

ObstacleKit::ObstacleKit() {
  SO_KIT_CONSTRUCTOR(ObstacleKit);

  SO_KIT_ADD_CATALOG_ENTRY(topSeparator, SoSeparator, TRUE, this,, FALSE);
  SO_KIT_ADD_CATALOG_ENTRY(transform,SoTransform,TRUE,topSeparator,,TRUE);
  SO_KIT_ADD_CATALOG_ENTRY(shape, Obstacle, TRUE, topSeparator,, TRUE);

  SO_KIT_INIT_INSTANCE();
}

ObstacleKit::~ObstacleKit() {
}






