#include <iostream.h>
#include "RobotSimulator.h"
#include "Path.h"

RobotSimulator::~RobotSimulator()
{
}


bool 
RobotSimulator::IsClear(const Milestone& m)
{
  cerr << "RobotSimulator::IsClear(m) : not implemented!\n";
  return false;
}

bool 
RobotSimulator::IsClear(const Milestone& m0, const Milestone& m1,
			IntervalType itype)
{
  cerr << "RobotSimulator::IsClear(m0,m1) : not implemented!\n";
  return false;
}


bool RobotSimulator::IsClear(const Path& p)
{
  bool clear=true;

  Path::const_iterator sb, se;
  sb=se=p.begin();
  for (se++; clear && se != p.end(); sb++, se++) 
    clear = IsClear(*sb, *se, SemiClosed);

  if (clear) clear = IsClear(*sb);
  
  return clear;
}


double 
RobotSimulator::WspDist(const GenCoords& p, const GenCoords& q)
{
  cerr << "RobotSimulator::WspDist : not implemented!\n";
  return 0.0;
}


double 
RobotSimulator::Cost(const GenCoords& p, const GenCoords& q)
{
  cerr << "RobotSimulator::Cost(p,q) : not implemented!\n";
  return 0.0;
}

double 
RobotSimulator::Cost(const Path& p)
{
  double c=0.0;

  Path::const_iterator sb, se;
  sb=se=p.begin();
  for (se++; se != p.end(); sb++, se++) {
    GenCoords qb((*sb).getConfig());
    GenCoords qe((*se).getConfig());
    c += Cost( qb, qe );
  }
  return c;
}


bool 
RobotSimulator::IK(const Pose& x, GenCoords *q, const GenCoords *q0)
{
  cerr << "RobotSimulator::IK : not implemented!\n";
  return false;
}

void 
RobotSimulator::FK(const GenCoords& q, Pose *x, int r)
{
  cerr << "RobotSimulator::FK : not implemented!\n";
}

const Pose& 
RobotSimulator::GetBase()
{
  cerr << "RobotSimulator::GetBase : not implemented!\n";
}

void 
RobotSimulator::SetBase(const Pose& basePose_)
{
  cerr << "RobotSimulator::SetBase : not implemented!\n";
}


void 
RobotSimulator::InterpolatePath(const Path& p, Path *ip, double res)
{
  cerr << "RobotSimulator::InterpolatePath : not implemented!\n";
}












