
/////////////////////////////////////////////////////////////
//
// Source file for ViewBoard
//
//    This file is generated by RapidApp 1.2
//
//    This class is derived from ViewBoardUI which 
//    implements the user interface created in 
//    RapidApp. This class contains virtual
//    functions that are called from the user interface.
//
//    When you modify this source, limit your changes to 
//    modifying the sections between the
//    "//---- Start/End editable code block" markers
//
//    This will allow RapidApp to integrate changes more easily
//
//    This class is a ViewKit user interface "component".
//    For more information on how components are used, see the
//    "ViewKit Programmers' Manual", and the RapidApp
//    User's Guide.
/////////////////////////////////////////////////////////////

#include "ViewBoard.h"
#include <Vk/VkEZ.h>
#include <Xm/BulletinB.h> 
#include <Xm/Label.h> 
#include <Xm/PushB.h> 
#include <Xm/Scale.h> 
#include <Xm/ToggleB.h> 
#include <Vk/VkResource.h>
#include <Vk/VkSimpleWindow.h>


extern void VkUnimplemented ( Widget, const char * );

///////////////////////////////////////////////////////////////////////////////
// The following non-container elements are created by ViewBoardUI and are
// available as protected data members inherited by this class
//
//  XmToggleButton		    _pathToggle
//  XmPushButton		    _playSR
//  XmPushButton		    _playSF
//  XmPushButton		    _playB
//  XmPushButton		    _playE
//  XmPushButton		    _playP
//  XmPushButton		    _playR
//  XmPushButton		    _playF
//  XmScale		    _frScale
//  XmLabel		    _frLabel1
//  XmLabel		    _frLabel
//  XmLabel		    _label
//  XmToggleButton		    _animToggle
//
///////////////////////////////////////////////////////////////////////////////


//---- Start editable code block: headers and declarations

#include "ViewMainWindow.h"

//---- End editable code block: headers and declarations



//---- ViewBoard Constructor

ViewBoard::ViewBoard(const char *name, Widget parent) : 
                   ViewBoardUI(name, parent) 
{ 
    // This constructor calls ViewBoardUI(parent, name)
    // which calls ViewBoardUI::create() to create
    // the widgets for this component. Any code added here
    // is called after the component's interface has been built

    //---- Start editable code block: ViewBoard constructor


    //---- End editable code block: ViewBoard constructor



}    // End Constructor



ViewBoard::ViewBoard(const char *name) : 
                   ViewBoardUI(name) 
 { 
    // This constructor calls ViewBoardUI(name)
    // which does not create any widgets. Usually, this
    // constructor is not used

    //---- Start editable code block: ViewBoard constructor 2


    //---- End editable code block: ViewBoard constructor 2



}    // End Constructor



ViewBoard::~ViewBoard()
{
    // The base class destructors are responsible for
    // destroying all widgets and objects used in this component.
    // Only additional items created directly in this class
    // need to be freed here.

    //---- Start editable code block: ViewBoard destructor


    //---- End editable code block: ViewBoard destructor



}    // End Destructor


const char * ViewBoard::className() // classname
{
    return ("ViewBoard");
} // End className()


void ViewBoard::doPlayB ( Widget w, XtPointer callData )
{
	//---- Start editable code block: ViewBoard doPlayB

	if (viewer != NULL) {
		viewer->animCmd(0);
	}

	//---- End editable code block: ViewBoard doPlayB

}    // End ViewBoard::doPlayB()


void ViewBoard::doPlayE ( Widget w, XtPointer callData )
{
	//---- Start editable code block: ViewBoard doPlayE

	if (viewer != NULL) {
		viewer->animCmd(6);
	}

	//---- End editable code block: ViewBoard doPlayE

}    // End ViewBoard::doPlayE()


void ViewBoard::doPlayF ( Widget w, XtPointer callData )
{
	//---- Start editable code block: ViewBoard doPlayF

		if (viewer != NULL) {
		viewer->animCmd(5);
	}

	//---- End editable code block: ViewBoard doPlayF

}    // End ViewBoard::doPlayF()


void ViewBoard::doPlayP ( Widget w, XtPointer callData )
{
	//---- Start editable code block: ViewBoard doPlayP

	if (viewer != NULL) {
		viewer->animCmd(3);
	}
	
	//---- End editable code block: ViewBoard doPlayP

}    // End ViewBoard::doPlayP()


void ViewBoard::doPlayR ( Widget w, XtPointer callData )
{
	//---- Start editable code block: ViewBoard doPlayR

	if (viewer != NULL) {
		viewer->animCmd(1);
	}

	//---- End editable code block: ViewBoard doPlayR

}    // End ViewBoard::doPlayR()


void ViewBoard::doPlaySF ( Widget w, XtPointer callData )
{
	//---- Start editable code block: ViewBoard doPlaySF

	if (viewer != NULL) {
		viewer->animCmd(4);
	}

	//---- End editable code block: ViewBoard doPlaySF

}    // End ViewBoard::doPlaySF()


void ViewBoard::doPlaySR ( Widget w, XtPointer callData )
{
	//---- Start editable code block: ViewBoard doPlaySR

	if (viewer != NULL) {
		viewer->animCmd(2);
	}

	//---- End editable code block: ViewBoard doPlaySR

}    // End ViewBoard::doPlaySR()


void ViewBoard::setAnimToggle ( Widget w, XtPointer callData )
{
	//---- Start editable code block: ViewBoard setAnimToggle

	if (viewer != NULL) {
		EZ(_animToggle) = viewer->toggleAnimation((int)EZ(_animToggle));
	}

	//---- End editable code block: ViewBoard setAnimToggle

}    // End ViewBoard::setAnimToggle()


void ViewBoard::setFrameRate ( Widget w, XtPointer callData )
{
	//---- Start editable code block: ViewBoard setFrameRate
	
	if (viewer != NULL) {
		if ((int)EZ(_frScale) > 0) {
			viewer->setFrameRate((int)EZ(_frScale));
		}
	}

	//---- End editable code block: ViewBoard setFrameRate

}    // End ViewBoard::setFrameRate()


void ViewBoard::setPathToggle ( Widget w, XtPointer callData )
{
	//---- Start editable code block: ViewBoard setPathToggle
	
	XmToggleButtonCallbackStruct *cbs = (XmToggleButtonCallbackStruct*) callData;

 	if (viewer != NULL) {
		EZ(_pathToggle) = viewer->togglePath((int)EZ(_pathToggle));
	}

	//---- End editable code block: ViewBoard setPathToggle

}    // End ViewBoard::setPathToggle()





///////////////////////////////////////////////////////////////////
// static creation function, for importing class into rapidapp
// or dynamically loading, using VkComponent::loadComponent
///////////////////////////////////////////////////////////////////


VkComponent *ViewBoard::CreateViewBoard( const char *name, Widget parent ) 
{  
    VkComponent *obj =  new ViewBoard ( name, parent );
    return ( obj );
} // End CreateViewBoard


///////////////////////////////////////////////////////////////////
// Function for accessing a description of the dynamic interface
// to this class.
///////////////////////////////////////////////////////////////////


// WARNING: This structure is different than that used with 1.1 RapidApp.
// See the RapidApp release notes for details

struct InterfaceMap {
  char  *resourceName;
  char  *methodName;
  char  *argType;
  char  *definingClass; // Optional, if not this class
  void (VkCallbackObject::*method)(...); // Reserved, do not set
};


void *ViewBoard::RegisterViewBoardInterface()
{ 
    // This structure registers information about this class
    // that allows RapidApp to create and manipulate an instance.
    // Each entry provides a resource name that will appear in the
    // resource manager palette when an instance of this class is
    // selected, the name of the member function as a string,
    // the type of the single argument to this function, and an.
    // optional argument indicating the class that defines this function.
    // All member functions must have the form
    //  
    //     void memberFunction ( Type );
    //
    // where "Type" is one of:
    //    const char *    (Use XmRString)
    //    Boolean         (Use XmRBoolean)
    //    int             (Use XmRInt)
    //    float           (Use XmRFloat)
    //    No argument     (Use VkRNoArg or "NoArg"
    //    A filename      (Use VkRFilename or "Filename")
    //    An enumeration  (Use "Enumeration:ClassName:Type: VALUE1, VALUE2, VALUE3")
    //    A callback      (Use XmRCallback)


    static InterfaceMap map[] = {
    //---- Start editable code block: ViewBoardUI resource table

      // { "resourceName", "setAttribute", XmRString},
    //---- End editable code block: ViewBoardUI resource table
      { NULL }, // MUST be NULL terminated
    };

    return map;
} // End RegisterViewBoardInterface()






//---- End of generated code

//---- Start editable code block: End of generated code


//---- End editable code block: End of generated code


