#include "revjointengine.h"

#include <Inventor/fields/SoSFRotation.h>

SO_ENGINE_SOURCE(RevJointEngine);

void RevJointEngine::initClass() {
  SO_ENGINE_INIT_CLASS(RevJointEngine, JointEngine, "JointEngine");
}

RevJointEngine::RevJointEngine() {
  SO_ENGINE_CONSTRUCTOR(RevJointEngine);

  SO_ENGINE_ADD_INPUT(axis, (0.0, 0.0, 0.0));
}

RevJointEngine::~RevJointEngine() {
}

void RevJointEngine::evaluate() {
  SbRotation newRot(axis.getValue(), val[0]);

  SO_ENGINE_OUTPUT(rot, SoSFRotation, setValue(newRot));
}
