#include "univjoint.h"

#include "univjointengine.h"
#include "univjointinvengine.h"

SO_NODE_SOURCE(UnivJoint);

void UnivJoint::initClass() {
  SO_NODE_INIT_CLASS(UnivJoint, Joint, "Joint");
}

UnivJoint::UnivJoint() {
  SO_NODE_CONSTRUCTOR(UnivJoint);

  engine = new UnivJointEngine;
  engine->ref();
  engine->val.connectFrom(&val);
  translation.connectFrom(&engine->trans);
	rotation.connectFrom(&engine->rot);

	invEngine = new UnivJointInvEngine();
	invEngine->ref();
	val.enableConnection(false);
	val.connectFrom(&invEngine->val);
}


UnivJoint::~UnivJoint() {
}

void UnivJoint::connectInvEngine(SoTransform *xform) {
	xform->translation = translation;
	xform->rotation = rotation;
	invEngine->trans.connectFrom(&xform->translation);
	invEngine->rot.connectFrom(&xform->rotation);
	val.enableConnection(true);
}

void UnivJoint::disconnectInvEngine() {
	val.enableConnection(false);
	invEngine->trans.disconnect();
	invEngine->rot.disconnect();
}
