#include "univjointengine.h"

#include <Inventor/fields/SoSFVec3f.h>
#include <Inventor/fields/SoSFRotation.h>

SO_ENGINE_SOURCE(UnivJointEngine);

void UnivJointEngine::initClass() {
  SO_ENGINE_INIT_CLASS(UnivJointEngine, JointEngine, "JointEngine");
}

UnivJointEngine::UnivJointEngine() {
  SO_ENGINE_CONSTRUCTOR(UnivJointEngine);
}

UnivJointEngine::~UnivJointEngine() {
}

void UnivJointEngine::evaluate() {
	if (val.getNum() >= 6) {
		SbVec3f newTrans(val[0], val[1], val[2]);
		double lastRotVal = 1 - (val[3]*val[3] + val[4]*val[4] + val[5]*val[5]);
		lastRotVal = sqrt(lastRotVal);
		SbRotation newRot(val[3], val[4], val[5], lastRotVal);
		
		SO_ENGINE_OUTPUT(trans, SoSFVec3f, setValue(newTrans));
		SO_ENGINE_OUTPUT(rot, SoSFRotation, setValue(newRot));
	}
}
