#include "univjointinvengine.h"

#include <Inventor/fields/SoMFFloat.h>

SO_ENGINE_SOURCE(UnivJointInvEngine);

void UnivJointInvEngine::initClass() {
  SO_ENGINE_INIT_CLASS(UnivJointInvEngine, JointInvEngine, "JointInvEngine");
}

UnivJointInvEngine::UnivJointInvEngine() {
  SO_ENGINE_CONSTRUCTOR(UnivJointInvEngine);
}

UnivJointInvEngine::~UnivJointInvEngine() {
}

void UnivJointInvEngine::evaluate() {
	SbVec3f t;
	SbRotation r;

	t = trans.getValue();
	r = rot.getValue();

	const float *quat = r.getValue();

	SO_ENGINE_OUTPUT(val, SoMFFloat, setNum(6));

	for (int i = 0; i < 3; i++) {
		SO_ENGINE_OUTPUT(val, SoMFFloat, set1Value(i, t[i])); 
	}
	for (int j = 0; j < 3; j++) {
		SO_ENGINE_OUTPUT(val, SoMFFloat, set1Value(j+3, quat[j]));
	}
}
